#
# Conditional build:
%bcond_without	doc	# HTML documentation build
%bcond_without	python2 # CPython 2.x module
%bcond_without	python3 # CPython 3.x module
%bcond_with	tests	# unit tests [fail with pytest 3.0?]

%define		module	py
Summary:	Library with cross-python path, ini-parsing, io, code, log facilities
Summary(pl.UTF-8):	Biblioteka wspierająca obsługę ścieżek, ini, we/wy, kodowania i logowania w wielu Pythonach
Name:		python-%{module}
Version:	1.11.0
Release:	6
License:	MIT
Group:		Development/Languages/Python
#Source0Download: https://pypi.org/simple/py/
Source0:	https://files.pythonhosted.org/packages/source/p/py/py-%{version}.tar.gz
# Source0-md5:	bde7dcc1cb452a1e10206ef2f811ba88
Patch0:		%{name}-pytest4.patch
Patch1:		intersphinx.patch
URL:		https://pypi.org/project/py/
%if %{with python2}
BuildRequires:	python-devel >= 1:2.7
BuildRequires:	python-setuptools >= 1:7.0
BuildRequires:	python-setuptools_scm
%if %{with tests}
%if %(locale -a | grep -q '^C\.utf8$'; echo $?)
BuildRequires:	glibc-localedb-all
%endif
BuildRequires:	python-attrs
BuildRequires:	python-pytest >= 2.9.0
%endif
%endif
%if %{with python3}
BuildRequires:	python3-devel >= 1:3.4
BuildRequires:	python3-modules >= 1:3.4
BuildRequires:	python3-setuptools >= 1:7.0
BuildRequires:	python3-setuptools_scm
%if %{with tests}
%if %(locale -a | grep -q '^C\.utf8$'; echo $?)
BuildRequires:	glibc-localedb-all
%endif
BuildRequires:	python3-attrs
BuildRequires:	python3-pytest >= 2.9.0
%endif
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%{?with_doc:BuildRequires:	sphinx-pdg >= 1.0}
%{?with_doc:BuildRequires:	python-devel-tools}
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
The py lib is a Python development support library featuring the
following tools and modules:
 - py.path: uniform local and svn path objects
 - py.apipkg: explicit API control and lazy-importing
 - py.iniconfig: easy parsing of .ini files
 - py.code: dynamic code generation and introspection

%description -l pl.UTF-8
Biblioteka py to biblioteka wpierająca tworzenie oprogramowania w
Pythonie. Zawiera następujące narzędzia i moduły:
 - py.path - jednolite obiekty ścieżek lokalnych i svn
 - py.apipkg - bezpośrednia kontrola API i leniwego importowania
 - py.iniconfig - łatwa analiza plików .ini
 - py.code - dynamiczne generowanie kodu i introspekcji

%package -n python3-py
Summary:	Library with cross-python path, ini-parsing, io, code, log facilities
Summary(pl.UTF-8):	Biblioteka wspierająca obsługę ścieżek, ini, we/wy, kodowania i logowania w wielu Pythonach
Group:		Development/Languages/Python

%description -n python3-py
The py lib is a Python development support library featuring the
following tools and modules:
- py.path: uniform local and svn path objects
- py.apipkg: explicit API control and lazy-importing
- py.iniconfig: easy parsing of .ini files
- py.code: dynamic code generation and introspection

%description -n python3-py -l pl.UTF-8
Biblioteka py to biblioteka wpierająca tworzenie oprogramowania w
Pythonie. Zawiera następujące narzędzia i moduły:
 - py.path - jednolite obiekty ścieżek lokalnych i svn
 - py.apipkg - bezpośrednia kontrola API i leniwego importowania
 - py.iniconfig - łatwa analiza plików .ini
 - py.code - dynamiczne generowanie kodu i introspekcji

%package apidocs
Summary:	Documentation for Python py library
Summary(pl.UTF-8):	Dokumentacja do biblioteki Pythona py
Group:		Documentation

%description apidocs
Documentation for Python py library.

%description apidocs -l pl.UTF-8
Dokumentacja do biblioteki Pythona py.

%prep
%setup -q -n %{module}-%{version}
%patch -P 0 -p1
%patch -P 1 -p1

%build
%if %{with python2}
%py_build

%if %{with tests}
LC_ALL=C.UTF-8 \
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
%{__python} -m pytest testing
%endif
%endif

%if %{with python3}
%py3_build

%if %{with tests}
LC_ALL=C.UTF-8 \
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
%{__python3} -m pytest testing
%endif
%endif

%if %{with doc}
PYTHONPATH=$(pwd) \
%{__make} -C doc html
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install

%py_postclean
%endif

%if %{with python3}
%py3_install
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc AUTHORS CHANGELOG.rst LICENSE README.rst
%{py_sitescriptdir}/%{module}
%{py_sitescriptdir}/%{module}-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n python3-py
%defattr(644,root,root,755)
%doc AUTHORS CHANGELOG.rst LICENSE README.rst
%{py3_sitescriptdir}/%{module}
%{py3_sitescriptdir}/%{module}-%{version}-py*.egg-info
%endif

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc doc/_build/html/{_modules,_static,announce,*.html,*.js}
%endif
%changelog
* Fri Mar 14 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-py.git;a=log;h=master

* Fri Mar 14 2025 Jan Rękorajski <baggins@pld-linux.org> 062cd86
- disable broken example in doc config, rel 6

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> 825e017
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> 173615c
- python 3.13 rebuild

* Sun Mar 09 2025 Jan Rękorajski <baggins@pld-linux.org> 49a3821
- use patch -P

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 496cd11
- rebuild with tests and docs

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 763514c
- rebuild with python 3.10

* Fri Mar 11 2022 Jakub Bogusz <qboosh@pld-linux.org> 2b51b12
- updated to 1.11.0
- added pytest4 patch from github (single failing test left now)

* Thu Dec 16 2021 Jakub Bogusz <qboosh@pld-linux.org> 67a1b28
- setuptools epoch

* Sun Feb 28 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> fc1a1a3
- release 3 (by relup.sh)

* Sun Feb 28 2021 Jan Rękorajski <baggins@pld-linux.org> bfc94c5
- release 2 (by relup.sh)

* Sat Feb 27 2021 Jan Palus <atler@pld-linux.org> 6ac4059
- noarch

* Sun Jan 31 2021 Jakub Bogusz <qboosh@pld-linux.org> 7911046
- updated to 1.10.0

* Tue Sep 15 2020 Jakub Bogusz <qboosh@pld-linux.org> 7142719
- updated to 1.9.0

* Sat Dec 28 2019 Jakub Bogusz <qboosh@pld-linux.org> 581622f
- updated to 1.8.1
- drop outdated intersphinx cache

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 6ee6610
- rebuild with python 3.8
- release 2 (by relup.sh)

* Sat Nov 24 2018 Jakub Bogusz <qboosh@pld-linux.org> a9ac464
- updated to 1.7.0

* Sun Jul 15 2018 Jakub Bogusz <qboosh@pld-linux.org> 7dfde63
- updated to 1.5.4

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 8d503f1
- release 2 (by relup.sh)

* Sat Mar 04 2017 Jakub Bogusz <qboosh@pld-linux.org> 5edc300
- updated to 1.4.32
- separated -apidocs instead of including over 2MB of docs in both python packages

* Wed Dec 28 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 8042723
- python3.6
- release 2 (by relup.sh)

